module Adminlock
  class AdminlockController < Adminlock::ApplicationController
    CRAWLER_REGEX = /crawl|googlebot|slurp|spider|bingbot|tracker|click|parser|spider/

    if self.respond_to?(:skip_before_action)
      skip_before_action :check_for_adminlock
    else
      skip_before_filter :check_for_adminlock
    end

    def unlock
      if params[:adminlock_codeword].present?
        user_agent = request.env['HTTP_USER_AGENT'].presence
        if user_agent && user_agent.downcase.match(CRAWLER_REGEX)
          head :ok
          return
        end

        @codeword = params[:adminlock_codeword].to_s.downcase
        @return_to = params[:return_to]
        if @codeword == adminlock_codeword.to_s.downcase
          set_cookie
          run_redirect
        end
      elsif request.post?
        if params[:adminlock].present? && params[:adminlock].respond_to?(:'[]')
          @codeword = params[:adminlock][:codeword].to_s.downcase
          @return_to = params[:adminlock][:return_to]
          if @codeword == adminlock_codeword.to_s.downcase
            set_cookie
            run_redirect
          else
            @wrong = true
          end
        else
          head :ok
        end
      else
        respond_to :html
      end
    end

    private

    def set_cookie
      cookies[:adminlock] = { value: @codeword.to_s.downcase, expires: (Time.now + adminlock_cookie_lifetime) }
    end

    def run_redirect
      if @return_to.present?
        redirect_to "#{@return_to}"
      else
        redirect_to '/'
      end
    end

  end
end